<!--
  Created by CPL.
  User: Carlos
  Date: 24/06/2024
  Time: 10:28
-->
<!doctype html>
<html xmlns:th="http://www.thymeleaf.org" lang="ES-es">
<head>
	<!-- Required meta tags -->
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	
	<!-- Bootstrap CSS -->
	<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet"
	      integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
	<!-- Bootstrap icons -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.11.2/font/bootstrap-icons.min.css">
	<!-- Estilos personalizados -->
	<link th:href="@{/css/.css}" type="text/css" rel="stylesheet">
	
	<title>Lista de clientes</title>
</head>
<body>
	<div class="container">
		<h1>Lista de clientes</h1>
		<!-- Mensaje de resultados de las acciones sobre los clientes desde la tabla -->
		<div class="alert alert-dismissible fade show" id="mensajeAlerta" role="alert" >
			<span></span>
		</div>
		 <!-- Tbla de datos -->
		<div class="row">
			<div class="col">
				<table class="table table-stripped">
					<tr>
						<th>Id</th>
						<th>Nombre</th>
						<th>Dni</th>
						<th>Edad</th>
						<th>Acciones</th>
					</tr>
					<th:block>
						<!--/* Si no hay clientes, se visualiza un mensaje. */-->
						<tr th:if="${clientes.size() == 0}" class="table-warning">
							<td>No se han encontrado clientes.</td>
						</tr>
						<!--/* Si hay clientes, generamos cada una de las filas desde la lista de clientes que recibimos
							desde el controlador mediante Thymeleaf
							ejemplo:
							<tr th:each="smokeTest : ${smokeTests}">
								<td th:text="${smokeTest.name}">A Smoke Test'</td>
							</tr>
							
							En la última columna colocamos los dos iconos: editar y borrar
						*/-->
						<tr th:unless="${clientes.size() == 0}" th:id="${cli.getId()}" th:each="cli : ${clientes}">
							<td th:text="${cli.getId()}"></td>
							<td th:text="${cli.getNombre()}"></td>
							<td th:text="${cli.getDni()}"></td>
							<td th:text="${cli.getEdad()}"></td>
							<!-- Columna para los iconos de acción -->
							<td>
								<i class="bi bi-pencil-fill me-2"
								   data-bs-target="#editaCliModal"
								   data-bs-toggle="modal"
								   th:attr="data-id=${cli.getId()},
								   data-nombre=${cli.getNombre()},
									data-dni=${cli.getDni()},
                                   data-edad=${cli.getEdad()}">
								</i>
								<i data-bs-target="#confirmaBorradoModal"
								   data-bs-toggle="modal"
								   class="bi bi-trash3-fill"
								   th:attr="data-id=${cli.getId()},
								    data-nombre=${cli.getNombre()}">
								</i>
							</td>
						</tr>
					</th:block>
				</table>
			</div>
		</div>
	</div>
	
	<!--  Modal para confirmar el borrado  -->
	<div class="modal fade" id="confirmaBorradoModal" tabindex="-1" aria-labelledby="confirmaBorradoModal"
	     aria-hidden="true">
		<div class="modal-dialog">
			<div class="modal-content">
				<div class="modal-header">
					<h5 class="modal-title">Confirmar borrado</h5>
					<button type="button" class="btn-close"  data-bs-dismiss="modal" aria-label="Close"></button>
				</div>
				<div class="modal-body">
				
				</div>
				<div class="modal-footer">
					<button type="submit" id="btnEliminar" class="btn btn-danger"
					        data-url = "" onclick="borrar(this)">Eliminar</button>
				</div>
			</div>
		</div>
	</div>
	
	<!-- Modal para editar la ficha de cliente -->
	<div class="modal fade" id="editaCliModal" tabindex="-1" aria-labelledby="editaCliModal"
	     aria-hidden="true">
		<div class="modal-dialog">
			<div class="modal-content">
				<form method="post" th:action="@{/clientes/datoscli}">
					<div class="modal-header">
						<h5 class="modal-title">Datos del cliente</h5>
						<button aria-label="Close" class="btn-close" data-bs-dismiss="modal" type="button"></button>
					</div>
					<div class="modal-body">
						<label for="id" class="form-label">id:</label>
						<input id="id" name="id" type="text" class="form-control">
						<label for="nombre" class="form-label">Nombre:</label>
						<input id="nombre" name="nombre" type="text" class="form-control">
						<label for="dni" class="form-label">Dni:</label>
						<input id="dni" name="dni" type="text" class="form-control">
						<label for="edad" class="form-label">Edad:</label>
						<input id="edad" name="edad" type="text" class="form-control">
					</div>
					<div class="modal-footer">
						<button class="btn btn-primary" id="btnConfirmas"
						        type="submit">Actualizar datos del cliente
						</button>
					</div>
				</form>
			</div>
		</div>
	</div>
	
	
	<!-- Optional JavaScript -->
	<script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.11.6/dist/umd/popper.min.js"
	        integrity="sha384-oBqDVmMz9ATKxIep9tiCxS/Z9fNfEXiDAYTujMAeBAsjFuCZSmKbSSUnQlmh/jp3"
	        crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.min.js"
	        integrity="sha384-cuYeSxntonz0PPNlHhBs68uyIAVpIIOZZ5JqeqvYYIcEL727kskC66kF92t6Xl2V"
	        crossorigin="anonymous"></script>
	
	<script th:inline="javascript">
		(function () {
			document.getElementById("editaCliModal").addEventListener("show.bs.modal", (event) => {
				// botón que ha disparado el modal
				const btn = event.relatedTarget;
				// Obtenemos los datos del atributo 'data-*'
				const datos = btn.dataset;
				// Actualizamos los campos del modal con los valores y fijamos el atributo action del formulario
				let titulo = event.target.querySelector('.modal-header>h5');
				titulo.textContent = 'Eliminar al cliente ' + datos['id'];
				// Fijamos el cuerpo del modal con los datos del cliente
				document.getElementById('id').value = datos['id']
				document.getElementById('nombre').value = datos['nombre']
				document.getElementById('dni').value = datos['dni']
				document.getElementById('edad').value = datos['edad']
			})
		})();
		
		(function () {
			document.getElementById("confirmaBorradoModal").addEventListener("show.bs.modal", (event) => {
				// botón que ha disparado el modal
				const btn = event.relatedTarget;
				// Obtenemos los datos del atributo 'data-*'
				const datos = btn.dataset;
				// Actualizamos los campos del modal con los valores y fijamos el atributo action del formulario
				let titulo = event.target.querySelector('.modal-header>h5');
				titulo.textContent = 'Eliminar al cliente ' + datos['id'];
				// Fijamos el cuerpo del modal con el mensaje  del nombre del cliente
				event.target.querySelector('.modal-body').innerHTML = '<p>Esta acción no se puede deshacer.<br>' +
						'¿Está seguro que desea eliminar permanentemente al cliente ' + datos['nombre'] + '</p>';
				document.getElementById("btnEliminar").dataset.id = datos['id'];
			})
		})();
		
		async function borrar(elem) {
			/*[- */ //Preparamos la llamada y esperamos la respuesta   /* -]*/
			const response = await fetch('/clientes/borrar2', {
				method: 'DELETE',
				headers: {'Content-Type': 'application/json'},
				body: JSON.stringify({id: elem.dataset.id})
			});
			const resp = await response.json();
			//console.log(resp);
			// cerramos el modal
			const modal = document.getElementById("confirmaBorradoModal");
			bootstrap.Modal.getInstance(modal).hide();
			// Ponemos el mensaje de resultado
			const msgAlert = document.getElementById('mensajeAlerta')
			msgAlert.classList.add('alert-' + resp.clase);
			document.querySelector("#mensajeAlerta>span").textContent = resp.mensaje;
			// Borramos la fila del cliente eliminado
			document.getElementById(elem.dataset.id).remove();
			// ... lo visualizamos ...
			msgAlert.style.visibility = 'visible'
			// ... y lo cerramos a los tres segundos
			setTimeout(function () {
				msgAlert.style.visibility = 'hidden'
			}, 2000)
		}
	</script>
</body>
</html>